Index: pbx.c
===================================================================
RCS file: /usr/cvsroot/asterisk/pbx.c,v
retrieving revision 1.235
diff -u -u -r1.235 pbx.c
--- pbx.c	1 May 2005 23:09:28 -0000	1.235
+++ pbx.c	3 May 2005 17:27:08 -0000
@@ -431,12 +431,13 @@
 
 	{ "SetVar", pbx_builtin_setvar,
 	"Set channel variable to value",
-	"  SetVar(#n1=value|#n2=value|..[|options]) \n"
+	"  SetVar([options|]#n1=value|#n2=value|..) \n"
 	"You can specify an endless list of name / value pairs to be set as channel variables.\n"
 	"  #n=value: Sets variable n to value. If prefixed with _, single\n"
 	"inheritance assumed. If prefixed with __, infinite inheritance is assumed.\n" 
-	"The last arg (if it doesn't contain an '=' ) is intrepreted as a string of\n"
-	"options. Valid Options:\n"
+	"Any arg (if it doesn't contain an '=' ) is intrepreted as a string of\n"
+	"options which apply to subsequent name/value pairs. Valid Options:\n"
+	"  - R - Reset, clears all the current flags.\n"
 	"  - c - CDR, if set set the var as a CDR variable also.\n"
 	"  - r - Recursive CDR, if there are any stacked CDRs, also apply to all as a cdr var.\n"
 	"  - g - Set a global variable not a channel variable.\n"
@@ -5799,15 +5800,15 @@
 						ast_cdr_setvar(chan->cdr, name, value, ast_test_flag(&flags, AST_CDR_FLAG_RECUR));
 					}
 				}
-			} else if (!next) {
-				name++;
-				if (strchr(name, 'c') ) {
+			} else {
+				fstr = name;
+				memset(&flags, 0, sizeof(flags));
+				if (strchr(fstr, 'c') ) {
 					ast_set_flag(&flags, AST_CDR_FLAG_SETVAR);
-				} else if (strchr(name, 'r') ) {
+				} else if (strchr(fstr, 'r') ) {
 					ast_set_flag(&flags, AST_CDR_FLAG_RECUR | AST_CDR_FLAG_SETVAR);
 				}
-			} else
-				ast_log(LOG_WARNING, "Ignoring entry '%s' with no = (and not last 'options' entry)\n", name);
+			}
 		}
 	} else {
 		ast_log(LOG_WARNING, "Ignoring, since there is no variable to set\n");
